<?php

function rand_float()
{
  return rand(0,0x7FFFFFFF) / (float)0x7FFFFFFF;
}

function HzVaryError($hz)
{
  $hz = (float)$hz;
  $hz = log2p12($hz);
  
  $error_range = 0.2;
  
  $hz += (pow(rand_float(), 14) * 2 - 1) * $error_range;
  
  $hz = pow(2, $hz/12.0);

  return (int)$hz;
}

class Phonetizer
{
  function CreatePho($token, $duration, $hzspots=Array())
  {
    $intpos = (int)($duration*1e3);
    $res = sprintf("%s %d", $token, $intpos);
    
    $this->pos += $intpos / 1e3;
    
    foreach($hzspots as $spot => $hz)
      $res .= sprintf(" %d %d", $spot, HzVaryError($hz));
    return "$res\n";
  }
  
  function CreateSilencePho($duration)
  {
    return $this->CreatePho('_', $duration);
  }
  
  function CreatePhoSeq($tokposlist, $duration, $hzspots)
  {
    $result = '';
    
    $newtokposlist = Array();
    $prev = false;
    foreach($tokposlist as $pos => $token)
    {
      $pos = min($duration, (float)$pos);
      if($prev !== false)
      {
        $newtokposlist[] = Array('begin'=>$prev['b'], 'end'=>$pos, 'tok'=>$prev['t']);
      }
      $prev = Array('b' => $pos, 't' => $token);
    }
    if($prev !== false)
      $newtokposlist[] = Array('begin'=>$prev['b'], 'end'=>(float)$duration, 'tok'=>$prev['t']);

    $pos = 0;
    while($pos < $duration)
    {
      $found = false;
      $next = Array('n' => 0, 'begin' => $duration);
      foreach($newtokposlist as $id => $tokdata)
      {
        if($tokdata['end'] <= $pos) continue; // already ended?
        if($tokdata['begin'] < $next['begin'])
          $next = Array('n' => $id, 'begin' => $tokdata['begin']);
      }
      if($next['begin'] > $pos)
      {
        // Fill in some silence
        $result .= CreateSilencePho($next['begin'] - $pos);
        $pos = $next['begin'];
        continue;
      }
      if($pos >= $duration) break;
      $pho = $newtokposlist[$next['n']];
      
      #print "pos($pos) dura($duration) b={$pho['begin']} e={$pho['end']} selected\n";
      
      $hzlist = Array();
      foreach($hzspots as $spot => $hz)
      {
        $spot = (float)$spot;
        
        if($spot >= $pos-0.0001 && $spot <= $pho['end']+0.0001)
        {
          $spot = ($spot - $pos) * 100 / ($pho['end'] - $pos);
          $hzlist[$spot] = $hz;
        }
      }
      
      #print_r($hzspots);
      
      $result .= $this->CreatePho($pho['tok'],
        $pho['end'] - $pos,
        $hzlist);
      $pos = $pho['end'];
    }
    return $result;
  }
};
